unit SpellOptionDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls, ComCtrls, NZCSSpellCheck;

type
  TFrmSpellOptions = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    BtnOK: TButton;
    BtnClose: TButton;
    BtnReCheck: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    ChkUpp: TCheckBox;
    ChkSuggest: TCheckBox;
    ChkIgnoreNum: TCheckBox;
    ChkIgnoreBrack: TCheckBox;
    ChkIgnoreFile: TCheckBox;
    ChkIgnoreNet: TCheckBox;
    Label2: TLabel;
    Bevel2: TBevel;
    Label3: TLabel;
    EdCustomDic: TEdit;
    SpeedButton1: TSpeedButton;
    ChkDupSpace: TCheckBox;
    ChkDupWord: TCheckBox;
    ChkMain: TCheckBox;
    procedure BtnOKClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BtnCloseClick(Sender: TObject);
    procedure BtnReCheckClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
  public
     CancelFlag: TDialogOptions;
     NZCSSpellChecker: TNZCSSpellCheck;
  end;

var
  FrmSpellOptions: TFrmSpellOptions;

implementation

{$R *.DFM}

procedure TFrmSpellOptions.BtnOKClick(Sender: TObject);
begin
   If Assigned(NZCSSpellChecker) then begin
      With NZCSSpellChecker do begin
         SpellingOptions := [];
         If ChkUpp.Checked then
            SpellingOptions := SpellingOptions + [spIgnoreAllUpperCase];
         If ChkSuggest.Checked then
            SpellingOptions := SpellingOptions + [spAlwaysSuggest];
         If ChkIgnoreNum.Checked then
            SpellingOptions := SpellingOptions + [spIgnoreNumbers];
         If ChkIgnoreBrack.Checked then
            SpellingOptions := SpellingOptions + [spIgnoreBrackets];
         If ChkIgnoreFile.Checked then
            SpellingOptions := SpellingOptions + [spIgnoreFiles];
         If ChkIgnoreNet.Checked then
            SpellingOptions := SpellingOptions + [spIgnoreInternet];
         If ChkDupSpace.Checked then
            SpellingOptions := SpellingOptions + [spDuplicateSpaces];
         If ChkDupWord.Checked then
            SpellingOptions := SpellingOptions + [spDuplicateWords];
         if ChkMain.Checked then
            SpellingOptions := SpellingOptions + [spMainDicOnly];
         if FileExists(EdCustomDic.Text) then
            CustomDictionary := EdCustomDic.Text;
         SaveSpellOptions;
      end;
   end;
end;

procedure TFrmSpellOptions.SpeedButton1Click(Sender: TObject);
var
  SD: TSaveDialog;
begin
   SD := TSaveDialog.Create(Application);
   Try
      SD.Filter := 'Dictionaries (*.dic)|*.dic';
      if SD.Execute then
         EdCustomDic.text := Sd.FileName;
   finally
      sd.free;
   end;
end;

procedure TFrmSpellOptions.BtnCloseClick(Sender: TObject);
begin
   Close;
end;

procedure TFrmSpellOptions.BtnReCheckClick(Sender: TObject);
begin
   If MessageDlg('This operation resets the spelling checker so that is will words you haven chosen to ignore. Continue?',
                 mtInformation,[MBYes, MbNo],0) = MRYes then begin
      BtnReCheck.Enabled := False;
      CancelFlag := scRestart;
   end;
end;

procedure TFrmSpellOptions.FormShow(Sender: TObject);
begin
   If Assigned(NZCSSpellChecker) then begin
      With NZCSSpellChecker do begin
         ChkMain.Checked :=        spMainDicOnly in SpellingOptions;
         ChkUpp.Checked :=         spIgnoreAllUpperCase in SpellingOptions;
         ChkSuggest.Checked :=     spAlwaysSuggest in SpellingOptions;
         ChkIgnoreNum.Checked :=   spIgnoreNumbers in SpellingOptions;
         ChkIgnoreBrack.Checked := spIgnoreBrackets in SpellingOptions;
         ChkIgnoreFile.Checked :=  spIgnoreFiles in SpellingOptions;
         ChkIgnoreNet.Checked :=   spIgnoreInternet in SpellingOptions;
         ChkDupSpace.Checked :=    spDuplicateSpaces in SpellingOptions;
         ChkDupWord.Checked :=     spDuplicateWords in SpellingOptions;
         if CustomDictionary <> '' then
            EdCustomDic.Text := CustomDictionary
         else begin
            CustomDictionary := FindCustomDic;
            EdCustomDic.Text := CustomDictionary
         end;
      end;
   end;
end;

end.
