unit spelldlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, NZCSSpellCheck;

type
  TFrmSpellCheck = class(TForm)
    Label1: TLabel;
    EBWrong: TEdit;
    Label2: TLabel;
    EBChangeTo: TEdit;
    Label3: TLabel;
    lstSuggest: TListBox;
    BtnIgnore: TButton;
    BtnIgnoreAll: TButton;
    BtnChange: TButton;
    BtnChangeAll: TButton;
    BtnAdd: TButton;
    BtnSuggest: TButton;
    Button7: TButton;
    btnCancel: TButton;
    procedure BtnIgnoreClick(Sender: TObject);
    procedure BtnIgnoreAllClick(Sender: TObject);
    procedure BtnChangeClick(Sender: TObject);
    procedure BtnChangeAllClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure BtnAddClick(Sender: TObject);
    procedure BtnSuggestClick(Sender: TObject);
    procedure lstSuggestClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EBChangeToKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EBChangeToKeyPress(Sender: TObject; var Key: Char);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    NZCSSpellChecker: TNZCSSpellCheck;
    Memo: TCustomMemo;
    StartWord, EndWord: Integer;
    CancelFlag: TDialogOptions;

  end;

var
  FrmSpellCheck: TFrmSpellCheck;

implementation

uses SpellOptionDlg;

{$R *.DFM}

procedure TFrmSpellCheck.BtnIgnoreClick(Sender: TObject);
begin
   CancelFlag := scIgnore;
   Close;
end;

procedure TFrmSpellCheck.BtnIgnoreAllClick(Sender: TObject);
begin
   CancelFlag := scIgnoreAll;
   Close;
end;

procedure TFrmSpellCheck.BtnChangeClick(Sender: TObject);
begin
   CancelFlag := scChange;
   If not NZCSSpellChecker.CheckWord(EBChangeTo.Text) then begin
      If Messagedlg('You have chose a word that is not found in the main or custom ' +
                  'dictionaries. Are you sure you want to use this word?', MtConfirmation, [MbYes, MbNo], 0) = MrNo then begin
         CancelFlag := scCancel;
         Exit;
      end;
      BtnSuggestClick(nil);
   end;
   Close;
end;

procedure TFrmSpellCheck.BtnChangeAllClick(Sender: TObject);
begin
   CancelFlag := scChangeAll;
   Close;
end;

procedure TFrmSpellCheck.btnCancelClick(Sender: TObject);
begin
   CancelFlag := scCancel;
   Close;
end;

procedure TFrmSpellCheck.BtnAddClick(Sender: TObject);
begin
   CancelFlag := scAdd;
   Close;
end;

procedure TFrmSpellCheck.BtnSuggestClick(Sender: TObject);
var
   Word: String;
begin
   With NZCSSpellChecker do begin
      If EBChangeTo.Text <> '' then
         Word := EBChangeTo.Text
      else
         Word := EBWrong.Text;
      GetSuggestions(Word, TStringList(FrmSpellCheck.lstSuggest.Items));
      If lstSuggest.Items.Count > 0 then
         EBChangeTo.Text := lstSuggest.Items[0];
   end;

end;

procedure TFrmSpellCheck.lstSuggestClick(Sender: TObject);
begin
   If lstSuggest.ItemIndex > -1 then begin
      EBChangeTo.Text := lstSuggest.Items[lstSuggest.ItemIndex];
      BtnIgnore.Default := False;
      BtnChange.Default := True;
   end;
end;

procedure TFrmSpellCheck.FormShow(Sender: TObject);
begin
   CancelFlag := scCancel;
   BtnIgnore.Default := True;
end;

procedure TFrmSpellCheck.EBChangeToKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
   strtemp: String;
   x: Integer;
begin
   If (Chr(Key) in ['a'..'z', 'A'..'Z','0'..'9']) Then begin
      strtemp := Uppercase(EBChangeTo.Text);
      For x := 0 To lstSuggest.items.Count - 1 do begin
         If UpperCase((strtemp + Copy(lstSuggest.items[x], Length(strtemp) + 1, length(lstSuggest.items[x])) )) = UpperCase(lstSuggest.items[x]) Then begin
           lstSuggest.itemIndex := x;
           Break;
         end;
      end;;
   end;
end;

procedure TFrmSpellCheck.EBChangeToKeyPress(Sender: TObject;
  var Key: Char);
begin
   BtnIgnore.Default := False;
   BtnChange.Default := True;
end;

procedure TFrmSpellCheck.Button7Click(Sender: TObject);
begin
   FrmSpellOptions := TFrmSpellOptions.Create(Self);
   FrmSpellOptions.CancelFlag := scCancel;
   FrmSpellOptions.NZCSSpellChecker := NZCSSpellChecker;
   FrmSpellOptions.Showmodal;
   If FrmSpellOptions.CancelFlag = scRestart then begin
      CancelFlag := FrmSpellOptions.CancelFlag;
      FrmSpellCheck.Free;
      Close;
   end;
end;

end.
